#!/usr/bin/perl
#
# SmoothWall CGIs
#
# This code is distributed under the terms of the GPL
#
# (c) SmoothWall Ltd 2003
#
###2006-0515 - Enhanced IPBlock Configuration Page v.0.3 modded by catastrophe
# - Intended for use on Smoothwall Express 2.0 fixes8 ui-3.6.1
# - Implementation of v2.3 pack system by Tiago Freitas Leal and Drew S. Dupont (NetWhiz) from QoS v1.8 mod
# - Incorporated (and enhanced) "ipinfo" and sorting command by KeyBoReD, can remove duplicate entries while sorting
# - Added new "notes" routine 
#	[v.0.3 ipblock.cgi was rewritten from the stock Smoothwall ipblock.cgi and does NOT contain "notes code" by jts and Scott R. Keszler (keszler) that was present in v.0.2]
# - Added default note for those IPs added by $ENV{'QUERY_STRING} (i.e. firewalllog.dat)
# - Added option to use the results of dns resolution for the note when editing or adding a new entry
#	(Routine adapted from Connview (conntrack-viewer-CAT.pl) by catastrophe which may also contain code from by Patrick Lagace and Venables)
# - Added "page generated in 'x' seconds" (thanks daniel_hozac)
# - Added "jump to bottom" and "jump to top", summary section, and "show raw" routine (some code adapted from Quikview)
###2006-0522 - Enhanced IPBlock Configuration Page v.0.3.1 modded by catastrophe
# - Implementation of modlib v2.3 final (2004-0815) by Tiago Freitas Leal and Drew S. Dupont (NetWhiz)
# - Compatible with IP Range to CIDR Calculator PACK V1.03 mod by KrisTof 
###
# - Disclaimer:
#    - Use at your own risk without any or implied warranty.
###

############
###HEADER###
############

require '/var/smoothwall/header.pl';

use Socket;
use Time::HiRes qw( gettimeofday );

###############
###VARIABLES###
###############

my (%cgiparams,%checked,%selected);
my $filename = "${swroot}/ipblock/config";	###default smoothwall ipblock config file
#my $filename2 = "${swroot}/ipblock/config";	###seems as if stock sw setipblock works on modded config file
my $filename2 = "${swroot}/ipblock/config2";	###use separate config so that uninstallation preserves blocklist 

my @vars;
#my $var, $addr;
my $var, $addr, $notesCAT;
my $needrestart = 0;

my $useCATdefaultnote = 'on';
my $defaultCATnote;
#@getthedateandtime = `date "+%Y-%m%d %R %Z"`; chomp (@getthedateandtime); $defaultCATnote = "Added on $getthedateandtime[0]";	###<---use date in default note											###2006-0420
#$defaultCATnote = "...";												###<---OR custom text for default note	
my $catpleasereolvethis;												###(OR comment both above to force dns note)
my $catresolved;
my $catsavemynote;
my $currentcount=0;
my $currentdrop=0;
my $currentlogged=0;
my $currentenabled=0;
my $currentreject=0;
my $activecount=0;

&showhttpheaders();

$t0 = gettimeofday();

$cgiparams{'ENABLED'} = 'off';
$cgiparams{'LOG'} = 'off';
$cgiparams{'CATNOTES'} = '';
$cgiparams{'CATSORT'} = 'off';		
$cgiparams{'CATNODOUBLE'} = 'off';	
$cgiparams{'CATDNSTRUNCATE'} = 'off';
$cgiparams{'CATDNSTRUNCATELEFT'} = 'on';
$cgiparams{'CATUSEDNSINSTEAD'} = '';
&getcgihash(\%cgiparams);

$catshowrawnow='off';	###enable raw viewing of /var/smoothwall/ipblock/config
$catrawlinenumbers='on';

system ("/bin/touch $filename2");

##########
###MENU###
##########

if ($ENV{'QUERY_STRING'} && $cgiparams{'ACTION'} eq '') {
	@vars = split(/\&/, $ENV{'QUERY_STRING'});
	foreach $_ (@vars) {
		($var, $addr) = split(/\=/);
#		if ($var eq 'ip') {
		if ($var eq 'ip')
		{
#			$addr =~ s/%2F/\//;	###compatibility with get_cidr/ipinfo V1.03 mod by KrisTof
			if (&validipormask($addr)) {
				if ($useCATdefaultnote eq 'on') {
					if ($defaultCATnote) {
						$catsavemynote = $defaultCATnote;
					} else {
						$catpleasereolvethis = $addr;
						&catresolvedns();			# if no default note defined, then use dns
						$catsavemynote = $cgiparams{'CATNOTES'}."\n";
						chomp ($catsavemynote);
						$cgiparams{'CATNOTES'} = '';
					}
				} 
				open(FILE2,">>$filename2") or die 'Unable to open config2 file.';
				flock FILE2, 2;
				if ($addr) {
					print FILE2 "$addr,off,DROP,on,$catsavemynote\n";
#					print FILE2 "$addr,off,DROP,on,$catsavemynote";
				}
				close(FILE2);
				$needrestart = 1;
			}
		}
	}
	if ($needrestart) {
		&catactivateipblocks();
	}
}

my $errormessage = '';

if ($cgiparams{'ACTION'} eq $tr{'add'}) {
	unless(&validipormask($cgiparams{'SRC_IP'})) { 
		$errormessage = $tr{'source ip bad'}; 
	}
	open(FILE2, $filename2) or die 'Unable to open config2 file.';
	my @current = <FILE2>;
	close(FILE2);
	unless ($errormessage)
	{
		if ($cgiparams{'CATUSEDNSINSTEAD'} eq 'on') {
			$catpleasereolvethis = $cgiparams{'SRC_IP'};
			&catresolvedns();
		} else {
			$catsavemynote = $cgiparams{'NOTES'};
		}
		open(FILE2,">>$filename2") or die 'Unable to open config2 file.';
		flock FILE2, 2;
		print FILE2 "$cgiparams{'SRC_IP'},$cgiparams{'LOG'},$cgiparams{'TARGET'},$cgiparams{'ENABLED'},$cgiparams{'CATNOTES'}\n";
		close(FILE2);
		&ipblockconfigCATsort();
		undef %cgiparams;
		&catactivateipblocks();
		&log($tr{'ip block rule added'});
	}
}
if ($cgiparams{'ACTION'} eq $tr{'remove'} || $cgiparams{'ACTION'} eq $tr{'edit'}) {
	open(FILE2, "$filename2") or die 'Unable to open config2 file.';
	my @current = <FILE2>;
	close(FILE2);

	my $count = 0;
	my $id = 0;
	my $line;
	foreach $line (@current) {
		$id++;
		if ($cgiparams{$id} eq "on") {
			$count++; }
	}
	if ($count == 0) {
		$errormessage = $tr{'nothing selected'}; 
	}
	if ($count > 1 && $cgiparams{'ACTION'} eq $tr{'edit'}) {
		$errormessage = $tr{'you can only select one item to edit'}; 
	}
	unless ($errormessage) {
		open(FILE2, ">$filename2") or die 'Unable to open config2 file.';
		flock FILE2, 2;
		$id = 0;
		foreach $line (@current) {
			$id++;
			unless ($cgiparams{$id} eq "on") {
				print FILE2 "$line"; 
			} elsif ($cgiparams{'ACTION'} eq $tr{'edit'}) {
				chomp($line);
				my @temp = split(/\,/,$line);
				$cgiparams{'SRC_IP'} = $temp[0];
				$cgiparams{'LOG'} = $temp[1];
				$cgiparams{'TARGET'} = $temp[2];
				$cgiparams{'ENABLED'} = $temp[3];
				$cgiparams{'CATNOTES'} = $temp[4];	
			}
		}
		close(FILE2);
		&catactivateipblocks();
		&log($tr{'ip block rule removed'});
	}
}
if ($cgiparams{'ACTION'} eq '') {
	$cgiparams{'TARGET'} = 'DROP';
	$cgiparams{'ENABLED'} = 'on';
}

$checked{'ENABLED'}{'off'} = '';
$checked{'ENABLED'}{'on'} = '';  
$checked{'ENABLED'}{$cgiparams{'ENABLED'}} = 'CHECKED';

$checked{'LOG'}{'off'} = '';
$checked{'LOG'}{'on'} = '';  
$checked{'LOG'}{$cgiparams{'LOG'}} = 'CHECKED';

$checked{'TARGET'}{'DROP'} = '';
$checked{'TARGET'}{'REJECT'} = '';
$checked{'TARGET'}{$cgiparams{'TARGET'}} = 'CHECKED';

$checked{'CATSORT'}{'off'} = '';						###2006-0422
$checked{'CATSORT'}{'on'} = '';						###2006-0422
$checked{'CATSORT'}{$cgiparams{'CATSORT'}} = 'CHECKED';		###2006-0422

$checked{'CATNODOUBLE'}{'off'} = '';					###2006-0422
$checked{'CATNODOUBLE'}{'on'} = '';					###2006-0422
$checked{'CATNODOUBLE'}{$cgiparams{'CATNODOUBLE'}} = 'CHECKED';	###2006-0422

$checked{'CATUSEDNSINSTEAD'}{'off'} = '';					###2006-0422
$checked{'CATUSEDNSINSTEAD'}{'on'} = '';					###2006-0422
$checked{'CATUSEDNSINSTEAD'}{$cgiparams{'CATUSEDNSINSTEAD'}} = 'CHECKED';	###2006-0422

#&openpage($tr{'ip block configuration'}, 1, '', 'networking');
&openpage($tr{'eip_dragbar'}, 1, '', 'networking');

&shownetworkingsection();

&openbigbox('100%', 'LEFT');

&alertbox($errormessage);

print "<FORM METHOD='POST'>\n";

&openbox('100%', 'LEFT', $tr{'add a new rule'});
print <<END
<TABLE WIDTH='100%'>
<TR>
<TD WIDTH='30%' CLASS='base'><FONT COLOR='$colourred'>$tr{'source ip or networkc'}</FONT> <INPUT TYPE='TEXT' NAME='SRC_IP' VALUE='$cgiparams{'SRC_IP'}' SIZE='15'></TD>
<TD WIDTH='15%' CLASS='base'><INPUT TYPE='radio' NAME='TARGET' VALUE='DROP' $checked{'TARGET'}{'DROP'}>$tr{'drop packet'}</TD>
<TD WIDTH='15%' CLASS='base'><INPUT TYPE='radio' NAME='TARGET' VALUE='REJECT' $checked{'TARGET'}{'REJECT'}>$tr{'reject packet'}</TD>
<TD WIDTH='10%' CLASS='base'>$tr{'logc'}<INPUT TYPE='checkbox' NAME='LOG' $checked{'LOG'}{'on'}></TD>
<TD WIDTH='10%' CLASS='base' ALIGN='CENTER'>$tr{'enabled'}<INPUT TYPE='CHECKBOX' NAME='ENABLED' $checked{'ENABLED'}{'on'}></TD>
</TR>
</TABLE>
<TABLE WIDTH='100%'>
<TR>
<TD WIDTH='11%' CLASS='base'>&nbsp;</TD>
<TD WIDTH='50%' CLASS='base'>&nbsp;&nbsp;$tr{'eip_notec'} <INPUT TYPE='TEXT' NAME='CATNOTES' SIZE='21'MAXLENGTH='35' VALUE='$cgiparams{'CATNOTES'}'>OR <INPUT TYPE='checkbox' NAME='CATUSEDNSINSTEAD' $checked{'CATUSEDNSINSTEAD'}{'on'}>Use DNS</TD>
<TD WIDTH='29%' CLASS='base'><INPUT TYPE='checkbox' NAME='CATSORT' $checked{'CATSORT'}{'on'}>$tr{'eip_sortbyip'} and  <INPUT TYPE='checkbox' NAME='CATNODOUBLE' $checked{'CATNODOUBLE'}{'on'}>$tr{'eip_removedupes'}</TD>
<TD WIDTH='10%' ALIGN='CENTER'><INPUT TYPE='SUBMIT' NAME='ACTION' VALUE='$tr{'add'}'></TD>
</TR>
</TABLE>
END
;
&closebox();

##########
###MAIN###
##########

&catshowipblockentries();
&catshowblocksummary();
&catshowraw();
&closebigbox();
&closepage($errormessage);
$t1 = gettimeofday(); $t2=$t1-$t0;
print "<PRE><center>Page generated in ", sprintf ('%.2f', $t2), " seconds.</center></PRE>";

##########
###DONE###
##########





#################
###SUBROUTINES###
#################

sub catshowipblockentries {
	&openbox('100%', 'LEFT', $tr{'current rules'});
	print qq|
	<TABLE WIDTH='100%' CELLSPACING='1'>
	<TR>
	<CENTER><a href="#bottom">$tr{'eip_jumptobottom'}</a></CENTER>
	<br>
	</TR>
	<TR>
	<TD WIDTH='15%' CLASS='boldbase' ALIGN='CENTER'><B>$tr{'source ip'}</B></TD>
	<TD WIDTH='5%' CLASS='boldbase' ALIGN='CENTER'>$tr{'eip_ipinfo'}</TD>
	<TD WIDTH='15%' CLASS='boldbase' ALIGN='CENTER'><B>$tr{'action'}</B></TD>
	<TD WIDTH='10%' CLASS='boldbase' ALIGN='CENTER'><B>$tr{'log'}</B></TD>
	<TD WIDTH='10%' CLASS='boldbase' ALIGN='CENTER'><B>$tr{'enabledtitle'}</B></TD>
	<TD WIDTH='40%' CLASS='boldbase' ALIGN='CENTER'><B>$tr{'eip_description'}</B></TD>
	<TD WIDTH='5%' CLASS='boldbase' ALIGN='CENTER'><B>$tr{'mark'}</B></TD>
	|;
	my $id = 0;
	open(RULES, "$filename2") or die 'Unable to open config2 file.';
	while (<RULES>) {
		my ($protocol, $loggif, $enabledgif);
		$id++;
		chomp($_);
		my @temp = split(/\,/,$_);
		if ($id % 2) {
			$colour = $table1colour;
		} else {
			$colour = $table2colour;
		}
		if ($temp[1] eq 'on') { 
			$loggif = 'on.gif';
		} else { 
			$loggif = 'off.gif'; 
		}
		if ($temp[3] eq 'on') {
			$enabledgif = 'on.gif'; 
			$currentenabled=$currentenabled+1;
			if ($temp[1] eq 'on') { 
				$currentlogged=$currentlogged+1;
			}
			if ($temp[2] eq 'DROP') {
				$currentdrop=$currentdrop+1;
			} elsif ($temp[2] eq 'REJECT') {
				$currentreject=$currentreject+1;
			}
		} else { 
			$enabledgif = 'off.gif'; 
		}

		@temp0cidr=split(/\//,$temp[0]);   ###2006-0420 - drop "/n" from "A.B.C.D/n" (catastrophe)
		print qq|
		<TR BGCOLOR='$colour'>
		<TD ALIGN='CENTER'>$temp[0]</TD>
		<TD ALIGN='CENTER'><a href=/cgi-bin/ipinfo.cgi?ip=$temp0cidr[0] target=_blank><img src='/ui/assets/3.5/img/help.gif' border=0></a></TD>
		<TD ALIGN='CENTER'>$temp[2]</TD>
		<TD ALIGN='CENTER'><IMG SRC='/ui/assets/3.5/img/$loggif'></TD>
		<TD ALIGN='CENTER'><IMG SRC='/ui/assets/3.5/img/$enabledgif'></TD>
		<TD ALIGN='CENTER'>$temp[4]</TD>
		<TD ALIGN='CENTER'><INPUT TYPE='CHECKBOX' NAME='$id'></TD>
		</TR>
		|;
	}
	close(RULES);
	$currentcount = $id;
	print qq|
	</TABLE>
	<TABLE WIDTH='100%'>
	<TR>
	<TD WIDTH='50%' ALIGN='CENTER'><INPUT TYPE='SUBMIT' NAME='ACTION' VALUE='$tr{'remove'}'></TD>
	<TD WIDTH='50%' ALIGN='CENTER'><INPUT TYPE='SUBMIT' NAME='ACTION' VALUE='$tr{'edit'}'></TD>
	</TR>
	<TR>
	<a name="bottom"></a><CENTER><a href="#top">$tr{'eip_jumptotop'}</a></CENTER>
	</TR>
	</TABLE>
	|;
	&alertbox('add', 'add');
	&closebox();
}

sub ipblockconfigCATsort {   ###2006-0422 - sort by ip and duplicate removal (catastrophe)
	$catnodouble = '';
	if ($cgiparams{'CATNODOUBLE'} eq 'on') {
		$catnodouble = "-u";		# leave out the duplicates (catastrophe) 
	}
	if ($cgiparams{'CATSORT'} eq 'on') {
		$catsortcommand = "/bin/sort -t . -k 1,1n -k 2,2n -k 3,3n -k 4,4n $filename2 $catnodouble -o $filename2";	# thanks KeyBoReD
		system($catsortcommand);
		&log("ipblock config sorted");
	}
}

sub catresolvedns {
	if ($catpleasereolvethis) {		###Routine adapted from Connview (conntrack-viewer-CAT.pl)
		if ($catresolved = gethostbyaddr(inet_aton($catpleasereolvethis),AF_INET)) { 
			if ($cgiparams{'CATDNSTRUNCATE'} eq "on") {	###truncate resolved names
				if ($cgiparams{'CATDNSTRUNCATELEFT'} eq "on") {	
					if (length($catresolved) > 35) { $catresolved = "...".( substr $catresolved, -32 ); };
				} else {
					if (length($catresolved) > 35) { $catresolved = ( substr $catresolved, 0, 32 )."..."; };
				}
			}
		} else {
			$catresolved = "UNRESOLVED!";
		}
	}
#	$catsavemynote = $catresolved;
	$cgiparams{'CATNOTES'} = $catresolved;
}

sub catshowraw {
	if ($catshowrawnow eq 'on') {
		&openbox('100%', 'LEFT', $tr{'eip_rawc'});
		@cateipFILENAME = `cat $filename`;
		chomp (@cateipFILENAME);
		print "<br>";
		for ($i=0; $i <= $#cateipFILENAME; $i++){
			chomp ($cateipFILENAME[$i]);
			$eipline = $cateipFILENAME[$i];
			&cateipLINEnumbers();
			print "<tt>$eipline\n</tt>";
			print "<br>";
		}
		&closebox();
	} 
}

sub cateipLINEnumbers {	###Routine adapted from Quikview (quikview.cgi)
	$eipspace="";
	if ($catrawlinenumbers eq 'on') {
		for ($nbspace=0; $nbspace<((length $#cateipFILENAME)-(length $i)); $nbspace=$nbspace+1) { 
			$eipspace=$eipspace."&nbsp;"; 
		}
		$eipline = "$eipspace$i&nbsp;&nbsp;&nbsp;$cateipFILENAME[$i]";
	} else {
		$eipline = "$cateipFILENAME[$i]";
	}
}

sub catactivateipblocks {		###strip modded config2 and copy to stock config then setipblock 
	@enhancedFILENAME2 = `cat $filename2`;
	chomp (@enhancedFILENAME2);
	open(FILE, ">$filename") or die 'Unable to open config file.';
	flock FILE, 2;
	for ($i=0; $i <= $#enhancedFILENAME2; $i++){
		chomp($enhancedFILENAME2[$i]);
		my @configtemp = split(/\,/,$enhancedFILENAME2[$i]);
		if ($configtemp[0]) {
			print FILE "$configtemp[0],$configtemp[1],$configtemp[2],$configtemp[3]\n";
		}
	}
	close(FILE);
	system('/usr/local/bin/setipblock');
}

sub catshowblocksummary {
	&openbox('100%', 'LEFT', $tr{'eip_summaryc'});
	print qq|
	<TR><TD>
	<center>
	$tr{'eip_enabledc'}
	<b>$currentenabled</b> / <b>$currentcount</b>
	&nbsp;&nbsp;&nbsp;&nbsp;
	$tr{'eip_droppedc'}
	<b>$currentdrop</b>
	&nbsp;&nbsp;&nbsp;&nbsp;
	$tr{'eip_rejectedc'}
	<b>$currentreject</b>
	&nbsp;&nbsp;&nbsp;&nbsp;
	$tr{'eip_loggedc'}
	<b>$currentlogged</b>
	</center>
	</TD></TR>
	|;
	&closebox();
}